module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/colors.ts":
/*!***********************!*\
  !*** ./src/colors.ts ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const theme_1 = __webpack_require__(/*! @workbench-stack/theme */ "@workbench-stack/theme");
const toggleReplaceButtonColors = {
    light: {
        backgroundHover: 'rgba(0, 0, 0, 0.1)',
    },
    dark: {
        backgroundHover: 'rgba(255, 255, 255, 0.1)',
    },
    hc: {
        backgroundHover: 'rgba(255, 255, 255, 0.1)',
    },
};
const inputColors = {
    light: {
        background: '#ccc',
        foreground: '#000',
    },
    dark: {
        background: '#373737',
        foreground: '#fff',
    },
    hc: {
        background: 'transparent',
        foreground: '#fff',
    },
};
const contentNodeColors = {
    light: {
        background: '#e3e6ef',
    },
    dark: {
        background: '#2a2d2e',
    },
    hc: {
        background: '2a2d2e',
    },
};
const contentNodeSelectedColors = {
    light: {
        background: '#3399ff',
        foreground: '#fff',
    },
    dark: {
        background: '#094771',
        foreground: 'inherit',
    },
    hc: {
        background: '#094771',
        foreground: 'inherit',
    },
};
const scrollColors = {
    light: {
        thumbBackground: '#ccc',
    },
    dark: {
        thumbBackground: '#373737',
    },
    hc: {
        thumbBackground: '#373737',
    },
};
const highlightColors = {
    light: {
        background: '#f0c1a3',
        replaceBackground: '#e2e8d4',
        delBackground: '#f6c3c3',
    },
    dark: {
        background: '#66371a',
        replaceBackground: '#3d432f',
        delBackground: '#511e1e',
    },
    hc: {
        background: '#66371a',
        replaceBackground: '#3d432f',
        delBackground: '#511e1e',
    },
};
exports.getToggleReplaceButtonColors = (theme) => {
    const backgroundHover = theme_1.getThemeSetting(theme.name, 'finderWidget.toggleReplaceButton.backgroundHover', toggleReplaceButtonColors[theme.name].backgroundHover);
    return {
        '&:hover': {
            'background-color': `${backgroundHover} !important`,
        },
    };
};
exports.getInputColors = (theme) => {
    const foreground = theme_1.getThemeSetting(theme.name, 'finderWidget.input.foreground', inputColors[theme.name].foreground);
    const background = theme_1.getThemeSetting(theme.name, 'finderWidget.input.background', inputColors[theme.name].background);
    return {
        '& input': {
            background,
            color: foreground,
            border: 'none',
            '&:focus': {
                border: '1px solid #387ba9 !important',
            },
        },
    };
};
exports.getNodeContentColors = (theme) => {
    const background = theme_1.getThemeSetting(theme.name, 'finderResults.contentNode.background', contentNodeColors[theme.name].background);
    const selectedBackground = theme_1.getThemeSetting(theme.name, 'finderResults.contentNode.selected.background', contentNodeSelectedColors[theme.name].background);
    const selectedForeground = theme_1.getThemeSetting(theme.name, 'finderResults.contentNode.selected.foreground', contentNodeSelectedColors[theme.name].foreground);
    return {
        '&:hover': {
            background,
        },
        '&.selected': {
            background: `${selectedBackground} !important`,
            color: `${selectedForeground} !important`,
        },
    };
};
exports.getScrollColors = (theme) => {
    const thumbBackground = theme_1.getThemeSetting(theme.name, 'finderResults.scrollBarThumbBackground', scrollColors[theme.name].thumbBackground);
    return {
        '&::-webkit-scrollbar-thumb': {
            background: thumbBackground,
        },
    };
};
exports.getHighlightColors = (theme) => {
    const background = theme_1.getThemeSetting(theme.name, 'finderResults.highlight.background', highlightColors[theme.name].background);
    const replaceBackground = theme_1.getThemeSetting(theme.name, 'finderResults.highlight.replaceBackground', highlightColors[theme.name].replaceBackground);
    const delBackground = theme_1.getThemeSetting(theme.name, 'finderResults.highlight.delBackground', highlightColors[theme.name].delBackground);
    return {
        '& mark': {
            color: 'inherit',
            backgroundColor: background,
            '&.green': {
                backgroundColor: replaceBackground,
            },
        },
        '& del': {
            color: 'inherit',
            backgroundColor: delBackground,
        },
    };
};


/***/ }),

/***/ "./src/find-results-tree-theme/index.ts":
/*!**********************************************!*\
  !*** ./src/find-results-tree-theme/index.ts ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tree_node_content_1 = __webpack_require__(/*! ./tree-node-content */ "./src/find-results-tree-theme/tree-node-content.tsx");
exports.nodeContentRenderer = tree_node_content_1.default;
var tree_node_1 = __webpack_require__(/*! ./tree-node */ "./src/find-results-tree-theme/tree-node.tsx");
exports.treeNodeRenderer = tree_node_1.default;
exports.scaffoldBlockPxWidth = 4;
exports.rowHeight = 22;
exports.slideRegionSize = 50;


/***/ }),

/***/ "./src/find-results-tree-theme/tree-node-content.tsx":
/*!***********************************************************!*\
  !*** ./src/find-results-tree-theme/tree-node-content.tsx ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const ReactDOM = __webpack_require__(/*! react-dom */ "react-dom");
const cx = __webpack_require__(/*! classnames */ "classnames");
const react_apollo_1 = __webpack_require__(/*! react-apollo */ "react-apollo");
const react_fela_1 = __webpack_require__(/*! react-fela */ "react-fela");
const react_redux_1 = __webpack_require__(/*! react-redux */ "react-redux");
const core_1 = __webpack_require__(/*! @files-stack/core */ "@files-stack/core");
const client_redux_1 = __webpack_require__(/*! @files-stack/client-redux */ "@files-stack/client-redux");
const client_redux_2 = __webpack_require__(/*! @finder-stack/client-redux */ "@finder-stack/client-redux");
const selector_1 = __webpack_require__(/*! ../selector */ "./src/selector.ts");
const colors_1 = __webpack_require__(/*! ../colors */ "./src/colors.ts");
const icons_1 = __webpack_require__(/*! ../icons */ "./src/icons.ts");
class TreeNodeContent extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = (e) => {
            e.preventDefault();
            const { node, path, parentNode } = this.props;
            if (node.isDirectory) {
                this.props.toggleChildrenVisibility({
                    node,
                    path,
                });
            }
            else {
                this.props.selectNode(node.id);
                if (parentNode && parentNode.resource) {
                    this.props.openFile(parentNode.resource, core_1.getFileName(parentNode.resource));
                    this.props.setFinderOptions({
                        lineNumber: node.lineNumber,
                        searchText: this.props.searchOptions.searchInput,
                    });
                }
            }
        };
        this.remove = () => {
            const { node, path } = this.props;
            this.props.removeNode(node, path);
        };
    }
    componentDidMount() {
        this.setPathWidth();
    }
    componentDidUpdate(prevProps, prevState) {
        this.setPathWidth();
    }
    setPathWidth() {
        if (this.fileNameRef && this.filePathRef) {
            const maxWidth = document.getElementById('finder-viewlet').clientWidth - 36;
            const nameWidth = ReactDOM.findDOMNode(this.fileNameRef)['clientWidth'];
            const width = maxWidth - nameWidth - 13;
            const element = ReactDOM.findDOMNode(this.filePathRef);
            element.style.width = `${Math.max(width, 0)}px`;
        }
    }
    nodeFolder(path) {
        const { searchOptions } = this.props;
        return core_1.getPath(path).replace(searchOptions.searchPath + '/', '');
    }
    nodePreview(preview) {
        const { searchOptions } = this.props;
        let nodePreview;
        const replace = searchOptions.expandReplace && searchOptions.replaceInput ?
            searchOptions.replaceInput : '';
        if (replace !== '') {
            nodePreview = preview.replace(searchOptions.searchInput, `<del>${searchOptions.searchInput}</del>
         <mark class="green">${replace}</mark>`);
        }
        else {
            nodePreview = preview.replace(searchOptions.searchInput, `<mark>${searchOptions.searchInput}</mark>`);
        }
        return (React.createElement("span", { dangerouslySetInnerHTML: { __html: nodePreview } }));
    }
    renderScaffold() {
        const { scaffoldBlockPxWidth, lowerSiblingCounts, styles, } = this.props;
        const scaffold = [];
        lowerSiblingCounts.forEach((lowerSiblingCount, i) => {
            scaffold.push(React.createElement("div", { key: `pre_${1 + i}`, style: { width: scaffoldBlockPxWidth }, className: styles.lineBlock }));
        });
        return scaffold;
    }
    render() {
        const { node, path, style, styles, selected, scaffoldBlockPxWidth, lowerSiblingCounts } = this.props;
        const nodeName = node.isDirectory ? node.file : this.nodePreview(node.preview);
        const tootipAttrs = {
            'data-for': 'finder-tooltip',
            'data-tip': node.isDirectory ? this.nodeFolder(node.folder) : node.preview.substring(0, 75),
        };
        const wrapperClassName = cx(styles.wrapper, {
            'selected': selected,
        });
        const rowClassName = cx(styles.row, {
            'has-children': node.isDirectory,
            'expanded': node.expanded,
        });
        const rowStyle = Object.assign({ width: `calc(100% - ${lowerSiblingCounts.length * scaffoldBlockPxWidth}px)` }, style);
        return (React.createElement("div", { ref: (r) => { this.containerRef = r; }, className: styles.node },
            React.createElement("div", { className: wrapperClassName },
                this.renderScaffold(),
                React.createElement("div", { className: rowClassName, style: rowStyle, onClick: this.handleClick },
                    React.createElement("div", { className: styles.label },
                        React.createElement("a", Object.assign({ ref: (r) => { this.fileNameRef = r; }, className: styles.fileName }, tootipAttrs), nodeName),
                        node.isDirectory &&
                            React.createElement("span", { ref: (r) => { this.filePathRef = r; }, className: styles.path }, this.nodeFolder(node.folder)))),
                React.createElement("a", { className: cx('close', styles.close), onClick: this.remove }))));
    }
}
TreeNodeContent.defaultProps = {
    parentNode: null,
    style: {},
};
const makeMapStateToProps = (initialState, ownProps) => {
    const getSelectedState = selector_1.makeGetSelectedState();
    const mapStateToProps = (state, props) => ({
        selected: getSelectedState(state, props),
        searchOptions: state['@finder/searchOptions'],
    });
    return mapStateToProps;
};
const mapDispatchToProps = (dispatch, props) => ({
    selectNode(id) {
        dispatch(client_redux_2.selectNodeAction(id));
    },
    openFile(resource, name) {
        dispatch(client_redux_1.openFileAction({ resource: core_1.getPath(resource), name }));
    },
    setFinderOptions: (options) => dispatch(client_redux_1.setFinderOptionsAction(options)),
});
exports.default = react_apollo_1.compose(react_redux_1.connect(makeMapStateToProps, mapDispatchToProps), react_fela_1.connect({
    node: () => ({
        position: 'relative',
        minWidth: '100%',
    }),
    wrapper: ({ theme }) => (Object.assign({ position: 'relative', display: 'flex', ':hover a.close': {
            display: 'inline-block',
        } }, colors_1.getNodeContentColors(theme))),
    lineBlock: () => ({
        height: '100%',
        position: 'relative',
        display: 'inline-block',
        flex: '0 0 auto',
    }),
    row: ({ theme }) => ({
        height: '100%',
        whiteSpace: 'nowrap',
        display: 'flex',
        position: 'relative',
        ':before': {
            paddingRight: '6px',
            width: '16px',
            height: '22px',
            display: 'inline-block',
            verticalAlign: 'top',
            content: '" "',
        },
        '&.has-children:before': {
            backgroundSize: '16px',
            backgroundPosition: '50% 50%',
            backgroundRepeat: 'no-repeat',
            backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).collapsed}")`,
        },
        '&.has-children.expanded:before': {
            backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).expanded}")`,
        },
    }),
    label: () => ({
        width: 'calc(100% - 28px)',
        cursor: 'pointer',
    }),
    close: ({ theme }) => ({
        position: 'absolute',
        display: 'none',
        verticalAlign: 'middle',
        cursor: 'pointer',
        height: '10px',
        width: '16px',
        top: '6px',
        right: '14px',
        backgroundSize: '16px',
        backgroundPosition: '50% 50%',
        backgroundRepeat: 'no-repeat',
        backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).close}")`,
    }),
    fileName: ({ theme }) => (Object.assign({ display: 'inline-block', verticalAlign: 'middle', overflow: 'hidden', textOverflow: 'ellipsis', maxWidth: 'calc(100% - 14px)', whiteSpace: 'nowrap' }, colors_1.getHighlightColors(theme))),
    path: () => ({
        display: 'inline-block',
        verticalAlign: 'middle',
        paddingLeft: '6px',
        opacity: '.7',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        whiteSpace: 'nowrap',
    }),
}))(react_fela_1.withTheme(TreeNodeContent));


/***/ }),

/***/ "./src/find-results-tree-theme/tree-node.tsx":
/*!***************************************************!*\
  !*** ./src/find-results-tree-theme/tree-node.tsx ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
exports.default = (props) => {
    const { style, children, listIndex, lowerSiblingCounts } = props;
    return (React.createElement("div", { style: style }, React.Children.map(children, (child) => React.cloneElement(child, {
        listIndex,
        lowerSiblingCounts,
    }))));
};


/***/ }),

/***/ "./src/find-results/find-results-component.tsx":
/*!*****************************************************!*\
  !*** ./src/find-results/find-results-component.tsx ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const ReactTooltip = __webpack_require__(/*! react-tooltip */ "react-tooltip");
const react_sortable_tree_1 = __webpack_require__(/*! @cdmbase/react-sortable-tree */ "@cdmbase/react-sortable-tree");
const core_1 = __webpack_require__(/*! @files-stack/core */ "@files-stack/core");
const FindResultsTreeTheme = __webpack_require__(/*! ../find-results-tree-theme */ "./src/find-results-tree-theme/index.ts");
class FindResultsComponent extends React.Component {
    constructor(props) {
        super(props);
        this.getTreeData = (results) => {
            const treeData = results.map((fileMatch) => ({
                resource: fileMatch.resource,
                folder: this.filterFolder(fileMatch.resource),
                file: core_1.getFileName(fileMatch.resource),
                children: fileMatch.lineMatches.map((lineMatch, i) => (Object.assign({}, lineMatch, { id: `${fileMatch.resource}_${i}` }))),
                isDirectory: true,
                expanded: true,
            }));
            this.setState({ treeData });
        };
        this.changeTree = (treeData) => {
            this.setState({ treeData });
        };
        this.removeNode = (node, path) => {
            const result = react_sortable_tree_1.removeNode({
                treeData: this.state.treeData,
                path,
                getNodeKey: ({ treeIndex }) => treeIndex,
            });
            this.changeTree(result.treeData);
        };
        this.state = {
            height: 0,
            treeData: [],
        };
    }
    componentWillReceiveProps(nextProps) {
        const { results } = nextProps;
        if (results && results.length !== this.props.results.length) {
            this.getTreeData(results);
        }
    }
    componentDidUpdate(prevProps, prevState) {
        const finderContainer = document.getElementById('finder-viewlet') || document.body;
        const finderHeader = document.getElementById('finder-header');
        const finderWidget = document.getElementById('finder-widget');
        const resultsState = document.getElementById('finder-results-stats');
        const containerHeight = finderContainer.clientHeight;
        let heightOffset = 0;
        if (resultsState) {
            heightOffset = heightOffset + resultsState.clientHeight;
        }
        if (finderHeader) {
            heightOffset = heightOffset + finderHeader.clientHeight;
        }
        if (finderWidget) {
            heightOffset = heightOffset + finderWidget.clientHeight;
        }
        const height = containerHeight - heightOffset;
        if (height !== this.state.height) {
            this.setState({ height });
        }
        if (this.state.treeData) {
            setTimeout(() => {
                ReactTooltip.rebuild();
            }, 100);
        }
    }
    filterFolder(resource) {
        return resource.replace(`file://${this.props.folder}/`, '');
    }
    renderStats() {
        const { results, styles } = this.props;
        const { treeData } = this.state;
        let matches = 0;
        let files = treeData.length;
        treeData.forEach((node) => {
            matches = matches + node.children.length;
        });
        return (React.createElement("div", { id: "finder-results-stats" },
            React.createElement("span", { className: styles.stats },
                matches,
                " results in ",
                files,
                " files")));
    }
    render() {
        const { styles, width } = this.props;
        const { treeData, height } = this.state;
        const nodeProps = (rowInfo) => ({
            removeNode: this.removeNode,
        });
        return (React.createElement("div", { ref: (r) => this.containerRef = r },
            this.renderStats(),
            React.createElement("div", { className: styles.list, style: { height, width } },
                React.createElement(react_sortable_tree_1.default, { id: "finder-folders-list", className: styles.tree, treeData: treeData, onChange: this.changeTree, theme: FindResultsTreeTheme, generateNodeProps: nodeProps }))));
    }
}
exports.FindResultsComponent = FindResultsComponent;


/***/ }),

/***/ "./src/find-results/find-results-container.ts":
/*!****************************************************!*\
  !*** ./src/find-results/find-results-container.ts ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(/*! react-fela */ "react-fela");
const react_redux_1 = __webpack_require__(/*! react-redux */ "react-redux");
const react_apollo_1 = __webpack_require__(/*! react-apollo */ "react-apollo");
const modal_1 = __webpack_require__(/*! @workbench-stack/modal */ "@workbench-stack/modal");
const find_results_component_1 = __webpack_require__(/*! ./find-results-component */ "./src/find-results/find-results-component.tsx");
const colors_1 = __webpack_require__(/*! ../colors */ "./src/colors.ts");
const mapStateToProps = (state) => ({
    width: state['resize'].treePanel,
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(modal_1.setError(error, type)),
});
exports.default = react_apollo_1.compose(...[
    react_fela_1.connect({
        stats: () => ({
            paddingLeft: '20px',
            opacity: '.5',
        }),
        list: () => ({
            position: 'relative',
            backgroundColor: 'transparent',
            overflow: 'hidden',
        }),
        tree: ({ theme }) => ({
            overflowY: 'auto',
            overflowX: 'hidden',
            '& .rst__virtualScrollOverride': Object.assign({ '&::-webkit-scrollbar': {
                    width: '6px',
                }, '&::-webkit-scrollbar-thumb': {
                    opacity: '.5',
                } }, colors_1.getScrollColors(theme)),
        }),
    }),
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
])(react_fela_1.withTheme(find_results_component_1.FindResultsComponent));


/***/ }),

/***/ "./src/find-results/index.ts":
/*!***********************************!*\
  !*** ./src/find-results/index.ts ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var find_results_container_1 = __webpack_require__(/*! ./find-results-container */ "./src/find-results/find-results-container.ts");
exports.FindResults = find_results_container_1.default;


/***/ }),

/***/ "./src/finder-widget/finder-widget-component.tsx":
/*!*******************************************************!*\
  !*** ./src/finder-widget/finder-widget-component.tsx ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const toggle_replace_button_1 = __webpack_require__(/*! ./toggle-replace-button */ "./src/finder-widget/toggle-replace-button.tsx");
const search_input_1 = __webpack_require__(/*! ./search-input */ "./src/finder-widget/search-input.tsx");
const query_details_1 = __webpack_require__(/*! ../query-details */ "./src/query-details/index.ts");
class FinderWidgetComponent extends React.Component {
    constructor(props) {
        super(props);
        this.keyDown = (e) => {
            if (e.key === 'Enter') {
                this.props.onSearch();
            }
        };
        this.setExpand = (expand) => {
            this.props.setSearchOptions({ expandReplace: expand });
        };
        this.changeSearch = (input) => {
            this.props.setSearchOptions({ searchInput: input });
        };
        this.changeReplace = (input) => {
            this.props.setSearchOptions({ replaceInput: input });
        };
    }
    render() {
        const { styles, searchOptions } = this.props;
        return (React.createElement("div", { id: "finder-widget", className: styles.container, onKeyDown: this.keyDown },
            React.createElement("div", { className: styles.searchInput },
                React.createElement(toggle_replace_button_1.ToggleReplaceButton, { styles: styles, expand: searchOptions.expandReplace, onUpdate: this.setExpand }),
                React.createElement(search_input_1.SearchInput, { styles: styles, placeholder: "Search", input: searchOptions.searchInput, onChange: this.changeSearch }),
                searchOptions.expandReplace === true &&
                    React.createElement(search_input_1.SearchInput, { styles: styles, placeholder: "Replace", isReplace: true, input: searchOptions.replaceInput, onChange: this.changeReplace })),
            React.createElement(query_details_1.QueryDetails, null)));
    }
}
exports.FinderWidgetComponent = FinderWidgetComponent;


/***/ }),

/***/ "./src/finder-widget/finder-widget-container.ts":
/*!******************************************************!*\
  !*** ./src/finder-widget/finder-widget-container.ts ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(/*! react-fela */ "react-fela");
const react_redux_1 = __webpack_require__(/*! react-redux */ "react-redux");
const react_apollo_1 = __webpack_require__(/*! react-apollo */ "react-apollo");
const modal_1 = __webpack_require__(/*! @workbench-stack/modal */ "@workbench-stack/modal");
const client_redux_1 = __webpack_require__(/*! @finder-stack/client-redux */ "@finder-stack/client-redux");
const finder_widget_component_1 = __webpack_require__(/*! ./finder-widget-component */ "./src/finder-widget/finder-widget-component.tsx");
const colors_1 = __webpack_require__(/*! ../colors */ "./src/colors.ts");
const icons_1 = __webpack_require__(/*! ../icons */ "./src/icons.ts");
const mapStateToProps = (state) => ({
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(modal_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            margin: '0px 9px 0 2px',
        }),
        searchInput: () => ({
            position: 'relative',
        }),
        toggleReplaceButton: ({ theme }) => (Object.assign({ position: 'absolute', top: '0', left: '0', width: '16px', height: '100%', '-webkit-box-sizing': 'border-box', '-o-box-sizing': 'border-box', '-moz-box-sizing': 'border-box', '-ms-box-sizing': 'border-box', 'box-sizing': 'border-box', 'background-position': 'center center', 'background-repeat': 'no-repeat', cursor: 'pointer', '&.collapse': {
                'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).collapsed}")`,
            }, '&.expand': {
                'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).expanded}")`,
            } }, colors_1.getToggleReplaceButtonColors(theme))),
        inputWrapper: ({ theme }) => (Object.assign({ fontSize: '13px', marginLeft: '17px', width: 'calc(100% - 17px) !important', height: '25px', position: 'relative', display: 'block', padding: '0', '-webkit-box-sizing': 'border-box', '-o-box-sizing': 'border-box', '-moz-box-sizing': 'border-box', '-ms-box-sizing': 'border-box', boxSizing: 'border-box', lineHeight: 'auto !important', '& .wrapper': {
                position: 'relative',
                width: '100%',
                height: '100%',
            } }, colors_1.getInputColors(theme))),
        inputBox: () => ({
            display: 'inline-block',
            '-webkit-box-sizing': 'border-box',
            '-o-box-sizing': 'border-box',
            '-moz-box-sizing': 'border-box',
            '-ms-box-sizing': 'border-box',
            'box-sizing': 'border-box',
            width: '100%',
            height: '100%',
            'line-height': 'inherit',
            border: 'none',
            'font-family': 'inherit',
            'font-size': 'inherit',
            resize: 'none',
            color: 'inherit',
            padding: '4px',
            'text-overflow': 'ellipsis',
            outline: 'none',
        }),
        replaceInputBox: () => ({
            marginTop: '6px',
            position: 'relative',
            display: 'inline-flex',
            '&.disabled': {
                display: 'none',
            },
        }),
        replaceAction: () => ({
            marginLeft: '3px',
        }),
        replaceActionIcon: ({ theme }) => ({
            display: 'block',
            'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).replaceAll}")`,
            'background-repeat': 'no-repeat',
            width: '20px',
            height: '25px',
        }),
    }),
])(react_fela_1.withTheme(finder_widget_component_1.FinderWidgetComponent));


/***/ }),

/***/ "./src/finder-widget/index.ts":
/*!************************************!*\
  !*** ./src/finder-widget/index.ts ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var finder_widget_container_1 = __webpack_require__(/*! ./finder-widget-container */ "./src/finder-widget/finder-widget-container.ts");
exports.FinderWidget = finder_widget_container_1.default;


/***/ }),

/***/ "./src/finder-widget/search-input.tsx":
/*!********************************************!*\
  !*** ./src/finder-widget/search-input.tsx ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const cx = __webpack_require__(/*! classnames */ "classnames");
class SearchInput extends React.Component {
    constructor(props) {
        super(props);
        this.changeInput = (e) => {
            this.props.onChange(e.target.value);
        };
    }
    render() {
        const { input, styles, placeholder, isReplace } = this.props;
        const className = isReplace ?
            cx(styles.inputWrapper, styles.replaceInputBox) : styles.inputWrapper;
        return (React.createElement("div", { className: className },
            React.createElement("div", { className: "wrapper" },
                React.createElement("input", { type: "text", placeholder: placeholder, value: input, onChange: this.changeInput, className: styles.inputBox })),
            isReplace &&
                React.createElement("div", { className: styles.replaceAction },
                    React.createElement("a", { className: styles.replaceActionIcon }))));
    }
}
exports.SearchInput = SearchInput;


/***/ }),

/***/ "./src/finder-widget/toggle-replace-button.tsx":
/*!*****************************************************!*\
  !*** ./src/finder-widget/toggle-replace-button.tsx ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const cx = __webpack_require__(/*! classnames */ "classnames");
class ToggleReplaceButton extends React.Component {
    constructor() {
        super(...arguments);
        this.handleClick = (e) => {
            const expand = this.props.expand === true;
            this.props.onUpdate(!expand);
        };
    }
    render() {
        const { styles, expand } = this.props;
        const className = cx(styles.toggleReplaceButton, {
            collapse: expand !== true,
            expand: expand === true,
        });
        return (React.createElement("a", { className: className, onClick: this.handleClick, title: "Toggle Replace" }));
    }
}
exports.ToggleReplaceButton = ToggleReplaceButton;


/***/ }),

/***/ "./src/finder-wrapper/finder-wrapper-component.tsx":
/*!*********************************************************!*\
  !*** ./src/finder-wrapper/finder-wrapper-component.tsx ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const ReactTooltip = __webpack_require__(/*! react-tooltip */ "react-tooltip");
const graphql_gql_1 = __webpack_require__(/*! @finder-stack/graphql-gql */ "@finder-stack/graphql-gql");
const utils_1 = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");
const finder_widget_1 = __webpack_require__(/*! ../finder-widget */ "./src/finder-widget/index.ts");
const find_results_1 = __webpack_require__(/*! ../find-results */ "./src/find-results/index.ts");
class FinderWrapperComponent extends React.Component {
    constructor(props) {
        super(props);
        this.search = () => {
            const { searchOptions, rootPath, configuration } = this.props;
            const searchPath = rootPath;
            const query = {
                type: 'Text',
                contentPattern: {
                    pattern: searchOptions.searchInput,
                },
                folderQueries: [{
                        folder: searchPath,
                        excludePattern: utils_1.getExcludes(configuration),
                    }],
            };
            if (searchOptions.expandDetail) {
                if (searchOptions.filesInclude !== '') {
                    const includePattern = {};
                    searchOptions.filesInclude.split(',').forEach((pattern) => {
                        includePattern[pattern.trim()] = true;
                    });
                    query['includePattern'] = includePattern;
                }
                if (searchOptions.filesExclude !== '') {
                    const excludePattern = {};
                    searchOptions.filesExclude.split(',').forEach((pattern) => {
                        excludePattern[pattern.trim()] = true;
                    });
                    query['excludePattern'] = excludePattern;
                }
            }
            this.props.setSearchOptions({ searchPath });
            this.setState({ results: [] });
            this.props.searchStreamMutate({ variables: { query } })
                .catch((error) => {
                this.props.setError(error.message, 'error');
                this.setState({ results: [] });
            });
        };
        this.state = {
            results: [],
        };
    }
    componentDidMount() {
        this.props.subscribeToMore({
            document: graphql_gql_1.SEARCH_STREAM_CONTENT_SUBSCRIPTION,
            updateQuery: (prev, { subscriptionData: { data } }) => {
                const { searchStreamContent } = data;
                const { results } = this.state;
                if (searchStreamContent) {
                    const resource = searchStreamContent.results[0].resource;
                    const findRes = results.find(el => el.resource === resource);
                    if (!findRes) {
                        this.setState({ results: [...results, ...searchStreamContent.results] });
                    }
                    else if (searchStreamContent.part !== null) {
                        if (searchStreamContent.part === -1) {
                            const newRes = results.map(el => {
                                if (el.resource === resource) {
                                    return Object.assign({}, el, { lineMatches: [Object.assign({}, el.lineMatches[0], { preview: el.lineMatches[0].preview + searchStreamContent.results[0].lineMatches[0].preview })] });
                                }
                                return el;
                            });
                            this.setState({ results: newRes });
                        }
                        else if (searchStreamContent.part >= 0) {
                            const newRes = results.map(el => {
                                if (el.resource === resource) {
                                    return Object.assign({}, el, { lineMatches: [
                                            ...el.lineMatches,
                                            ...searchStreamContent.results[0].lineMatches,
                                        ] });
                                }
                                return el;
                            });
                            this.setState({ results: newRes });
                        }
                    }
                }
            },
            onError: (err) => {
                this.props.setError(err.message, 'error');
            },
        });
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("div", { ref: (r) => this.containerRef = r, className: styles.container, id: "finder-viewlet" },
            React.createElement("div", { className: styles.header, id: "finder-header" },
                React.createElement("span", null, "Search")),
            React.createElement(finder_widget_1.FinderWidget, { onSearch: this.search }),
            React.createElement(find_results_1.FindResults, { results: this.state.results }),
            React.createElement(ReactTooltip, { id: "finder-tooltip", className: styles.tooltip, place: "bottom", type: "light", effect: "solid", delayShow: 1000, delayHide: 1000 })));
    }
}
exports.FinderWrapperComponent = FinderWrapperComponent;


/***/ }),

/***/ "./src/finder-wrapper/finder-wrapper-container.ts":
/*!********************************************************!*\
  !*** ./src/finder-wrapper/finder-wrapper-container.ts ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(/*! react-fela */ "react-fela");
const react_redux_1 = __webpack_require__(/*! react-redux */ "react-redux");
const react_apollo_1 = __webpack_require__(/*! react-apollo */ "react-apollo");
const reselect_1 = __webpack_require__(/*! reselect */ "reselect");
const modal_1 = __webpack_require__(/*! @workbench-stack/modal */ "@workbench-stack/modal");
const graphql_gql_1 = __webpack_require__(/*! @finder-stack/graphql-gql */ "@finder-stack/graphql-gql");
const client_redux_1 = __webpack_require__(/*! @finder-stack/client-redux */ "@finder-stack/client-redux");
const preferences_module_browser_1 = __webpack_require__(/*! @workbench-stack/preferences-module-browser */ "@workbench-stack/preferences-module-browser");
const finder_wrapper_component_1 = __webpack_require__(/*! ./finder-wrapper-component */ "./src/finder-wrapper/finder-wrapper-component.tsx");
const FinderWrapperApi = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.SEARCH_MUTATION, { name: 'searchMutate' }), react_apollo_1.graphql(graphql_gql_1.SEARCH_STREAM_MUTATION, { name: 'searchStreamMutate' }), react_apollo_1.graphql(preferences_module_browser_1.CONFIGURATION_QUERY, {
    options: () => ({ variables: { service: 'search' } }),
    props: reselect_1.createSelector(({ ownProps, data }) => data, (data) => {
        return {
            configuration: data.configuration && JSON.parse(data.configuration.data),
            subscribeToMore: data.subscribeToMore,
        };
    }),
}))(finder_wrapper_component_1.FinderWrapperComponent);
const mapStateToProps = (state) => ({
    rootPath: state['@files/rootpath'],
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(modal_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
const FinderWrapper = react_apollo_1.compose(...[
    react_fela_1.connect({
        container: () => ({
            position: 'relative',
            height: '100%',
            width: '100%',
            '& .__react_component_tooltip': {
                position: 'absolute',
                padding: '2px 4px',
                fontSize: '12px',
                lineHeight: '1.2',
                maxWidth: '100%',
                wordWrap: 'break-word',
                borderRadius: '1px',
            },
            '& .__react_component_tooltip::after': {
                display: 'none',
            },
            '& .__react_component_tooltip.place-bottom': {
                marginTop: '0',
            },
        }),
        header: () => ({
            padding: '9px 22px 0',
            textTransform: 'uppercase',
            fontSize: '0.8em',
            height: '20px',
        }),
    }),
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
])(FinderWrapperApi);
exports.default = FinderWrapper;


/***/ }),

/***/ "./src/finder-wrapper/index.ts":
/*!*************************************!*\
  !*** ./src/finder-wrapper/index.ts ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var finder_wrapper_container_1 = __webpack_require__(/*! ./finder-wrapper-container */ "./src/finder-wrapper/finder-wrapper-container.ts");
exports.Finder = finder_wrapper_container_1.default;


/***/ }),

/***/ "./src/icons.ts":
/*!**********************!*\
  !*** ./src/icons.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const collapsed = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#646465' d='M6 4v8l4-4-4-4zm1 2.414l1.586 1.586-1.586 1.586v-3.172z'/%3E%3C/svg%3E";
const collapsedDark = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#e8e8e8' d='M6 4v8l4-4-4-4zm1 2.414l1.586 1.586-1.586 1.586v-3.172z'/%3E%3C/svg%3E";
const expanded = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#646465' d='M11 10.07h-5.656l5.656-5.656v5.656z'/%3E%3C/svg%3E";
const expandedDark = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#e8e8e8' d='M11 10.07h-5.656l5.656-5.656v5.656z'/%3E%3C/svg%3E";
const replaceAll = "%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='0 0 16 16' enableBackground='new 0 0 16 16' xml:space='preserve'%3E%3Cg id='icon_x5F_bg'%3E%3Cpath fill='#424242' d='M11,15V9H1v6H11z M2,14v-2h1v-1H2v-1h3v4H2z M10,11H8v2h2v1H7v-4h3V11z M3,13v-1h1v1H3z M13,7v6h-1V8H5V7 H13z M13,2V1h-1v5h3V2H13z M14,5h-1V3h1V5z M11,2v4H8V4h1v1h1V4H9V3H8V2H11z'/%3E%3C/g%3E%3Cg id='color_x5F_action'%3E%3Cpath fill='#00539C' d='M1.979,3.5L2,6L1,5v1.5L2.5,8L4,6.5V5L3,6L2.979,3.5c0-0.275,0.225-0.5,0.5-0.5H7V2H3.479 C2.651,2,1.979,2.673,1.979,3.5z'/%3E%3C/g%3E%3C/svg%3E";
const replaceAllInverse = "%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='0 0 16 16' enable-background='new 0 0 16 16' xml:space='preserve'%3E%3Cg id='icon_x5F_bg'%3E%3Cpath fill='#C5C5C5' d='M11,15V9H1v6H11z M2,14v-2h1v-1H2v-1h3v4H2z M10,11H8v2h2v1H7v-4h3V11z M3,13v-1h1v1H3z M13,7v6h-1V8H5V7 H13z M13,2V1h-1v5h3V2H13z M14,5h-1V3h1V5z M11,2v4H8V4h1v1h1V4H9V3H8V2H11z'/%3E%3C/g%3E%3Cg id='color_x5F_action'%3E%3Cpath fill='#75BEFF' d='M1.979,3.5L2,6L1,5v1.5L2.5,8L4,6.5V5L3,6L2.979,3.5c0-0.275,0.225-0.5,0.5-0.5H7V2H3.479 C2.651,2,1.979,2.673,1.979,3.5z'/%3E%3C/g%3E%3C/svg%3E";
const ellipsis = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cg fill='#F6F6F6'%3E%3Ccircle cx='3.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='2.5'/%3E%3C/g%3E%3Cg fill='#424242'%3E%3Ccircle cx='3.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='1.5'/%3E%3C/g%3E%3C/svg%3E";
const ellipsisInverse = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cg fill='#262626'%3E%3Ccircle cx='3.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='2.5'/%3E%3C/g%3E%3Cg fill='#C5C5C5'%3E%3Ccircle cx='3.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='1.5'/%3E%3C/g%3E%3C/svg%3E";
const close = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#424242' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
const closeDark = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#FFF' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
exports.getIcons = (theme) => {
    if (theme.name === 'dark' || theme.name === 'hc') {
        return {
            collapsed: collapsedDark,
            expanded: expandedDark,
            replaceAll: replaceAllInverse,
            ellipsis: ellipsisInverse,
            close: closeDark,
        };
    }
    else {
        return {
            collapsed,
            expanded,
            replaceAll,
            ellipsis,
            close,
        };
    }
};


/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(/*! ./finder-wrapper */ "./src/finder-wrapper/index.ts"));


/***/ }),

/***/ "./src/query-details/files-input.tsx":
/*!*******************************************!*\
  !*** ./src/query-details/files-input.tsx ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const cx = __webpack_require__(/*! classnames */ "classnames");
class FilesInput extends React.Component {
    constructor() {
        super(...arguments);
        this.change = (e) => {
            this.props.onChange(e.target.value);
        };
    }
    render() {
        const { styles, input, isExclude } = this.props;
        const className = isExclude ?
            cx(styles.inputWrapper, styles.filesExcludeBox) : styles.inputWrapper;
        return (React.createElement("div", { className: styles.inputBox },
            React.createElement("span", null, isExclude ? 'files to exclude' : 'files to include'),
            React.createElement("div", { className: "wrapper" },
                React.createElement("input", { type: "text", value: input, onChange: this.change, className: styles.inputBox }))));
    }
}
exports.FilesInput = FilesInput;


/***/ }),

/***/ "./src/query-details/index.ts":
/*!************************************!*\
  !*** ./src/query-details/index.ts ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var query_details_container_1 = __webpack_require__(/*! ./query-details-container */ "./src/query-details/query-details-container.ts");
exports.QueryDetails = query_details_container_1.default;


/***/ }),

/***/ "./src/query-details/query-details-component.tsx":
/*!*******************************************************!*\
  !*** ./src/query-details/query-details-component.tsx ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
const toggle_search_details_button_1 = __webpack_require__(/*! ./toggle-search-details-button */ "./src/query-details/toggle-search-details-button.tsx");
const files_input_1 = __webpack_require__(/*! ./files-input */ "./src/query-details/files-input.tsx");
class QueryDetailsComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.setExpand = (expand) => {
            if (!expand) {
                this.props.setSearchOptions({
                    expandDetail: expand,
                    filesInclude: '',
                    filesExclude: '',
                });
            }
            else {
                this.props.setSearchOptions({
                    expandDetail: expand,
                });
            }
        };
        this.changeFilesInclude = (path) => {
            this.props.setSearchOptions({ filesInclude: path });
        };
        this.changeFilesExclude = (path) => {
            this.props.setSearchOptions({ filesExclude: path });
        };
    }
    render() {
        const { styles, searchOptions } = this.props;
        return (React.createElement("div", { ref: (r) => this.containerRef = r, className: styles.container },
            React.createElement(toggle_search_details_button_1.ToggleSearchDetailsButton, { styles: styles, expand: searchOptions.expandDetail, onUpdate: this.setExpand }),
            searchOptions.expandDetail === true &&
                React.createElement(files_input_1.FilesInput, { styles: styles, input: searchOptions.filesInclude, onChange: this.changeFilesInclude }),
            searchOptions.expandDetail === true &&
                React.createElement(files_input_1.FilesInput, { styles: styles, isExclude: true, input: searchOptions.filesExclude, onChange: this.changeFilesExclude })));
    }
}
exports.QueryDetailsComponent = QueryDetailsComponent;


/***/ }),

/***/ "./src/query-details/query-details-container.ts":
/*!******************************************************!*\
  !*** ./src/query-details/query-details-container.ts ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(/*! react-fela */ "react-fela");
const react_redux_1 = __webpack_require__(/*! react-redux */ "react-redux");
const react_apollo_1 = __webpack_require__(/*! react-apollo */ "react-apollo");
const modal_1 = __webpack_require__(/*! @workbench-stack/modal */ "@workbench-stack/modal");
const client_redux_1 = __webpack_require__(/*! @finder-stack/client-redux */ "@finder-stack/client-redux");
const query_details_component_1 = __webpack_require__(/*! ./query-details-component */ "./src/query-details/query-details-component.tsx");
const colors_1 = __webpack_require__(/*! ../colors */ "./src/colors.ts");
const icons_1 = __webpack_require__(/*! ../icons */ "./src/icons.ts");
const mapStateToProps = (state) => ({
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(modal_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
const QueryDetails = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            minHeight: '1em',
            position: 'relative',
            margin: '5px 0 0 17px',
        }),
        toggleSearchDetailsButton: ({ theme }) => ({
            position: 'absolute',
            marginRight: '0.3em',
            right: '0',
            cursor: 'pointer',
            width: '16px',
            height: '13px',
            zIndex: '2',
            background: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).ellipsis}") top center no-repeat`,
        }),
        inputWrapper: ({ theme }) => (Object.assign({ width: '100%', display: 'block', position: 'relative', paddingTop: '5px', fontSize: '12px', '&:last-child': {
                paddingBottom: '10px',
            }, '& .wrapper': {
                position: 'relative',
                height: '25px',
                width: '100%',
            } }, colors_1.getInputColors(theme))),
        inputBox: () => ({
            display: 'inline-block',
            '-webkit-box-sizing': 'border-box',
            '-o-box-sizing': 'border-box',
            '-moz-box-sizing': 'border-box',
            '-ms-box-sizing': 'border-box',
            'box-sizing': 'border-box',
            width: '100%',
            height: '100%',
            'line-height': 'inherit',
            border: 'none',
            'font-family': 'inherit',
            'font-size': 'inherit',
            resize: 'none',
            color: 'inherit',
            padding: '4px',
            'text-overflow': 'ellipsis',
            outline: 'none',
        }),
    }),
])(react_fela_1.withTheme(query_details_component_1.QueryDetailsComponent));
exports.default = QueryDetails;


/***/ }),

/***/ "./src/query-details/toggle-search-details-button.tsx":
/*!************************************************************!*\
  !*** ./src/query-details/toggle-search-details-button.tsx ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(/*! react */ "react");
class ToggleSearchDetailsButton extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }
    handleClick(e) {
        const expand = this.props.expand === true;
        this.props.onUpdate(!expand);
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("a", { className: styles.toggleSearchDetailsButton, onClick: this.handleClick, title: "Toggle Search Details" }));
    }
}
exports.ToggleSearchDetailsButton = ToggleSearchDetailsButton;


/***/ }),

/***/ "./src/selector.ts":
/*!*************************!*\
  !*** ./src/selector.ts ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const reselect_1 = __webpack_require__(/*! reselect */ "reselect");
exports.makeGetSelectedState = () => {
    return reselect_1.createSelector((state, props) => ({ node: props.node, selectedNode: state['@finder/selectedNode'] }), ({ node, selectedNode }) => (node && node.id && node.id === selectedNode));
};


/***/ }),

/***/ "./src/utils/index.ts":
/*!****************************!*\
  !*** ./src/utils/index.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const objects = __webpack_require__(/*! @vscode/base-node/vs/base/common/objects */ "@vscode/base-node/vs/base/common/objects");
exports.getExcludes = configuration => {
    const fileExcludes = configuration && configuration.files && configuration.files.exclude;
    const searchExcludes = configuration && configuration.search && configuration.search.exclude;
    if (!fileExcludes && !searchExcludes) {
        return undefined;
    }
    if (!fileExcludes || !searchExcludes) {
        return fileExcludes || searchExcludes;
    }
    let allExcludes = Object.create(null);
    allExcludes = objects.mixin(allExcludes, objects.deepClone(fileExcludes));
    allExcludes = objects.mixin(allExcludes, objects.deepClone(searchExcludes), true);
    return allExcludes;
};


/***/ }),

/***/ "@cdmbase/react-sortable-tree":
/*!***********************************************!*\
  !*** external "@cdmbase/react-sortable-tree" ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@cdmbase/react-sortable-tree");

/***/ }),

/***/ "@files-stack/client-redux":
/*!********************************************!*\
  !*** external "@files-stack/client-redux" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@files-stack/client-redux");

/***/ }),

/***/ "@files-stack/core":
/*!************************************!*\
  !*** external "@files-stack/core" ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@files-stack/core");

/***/ }),

/***/ "@finder-stack/client-redux":
/*!*********************************************!*\
  !*** external "@finder-stack/client-redux" ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@finder-stack/client-redux");

/***/ }),

/***/ "@finder-stack/graphql-gql":
/*!********************************************!*\
  !*** external "@finder-stack/graphql-gql" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@finder-stack/graphql-gql");

/***/ }),

/***/ "@vscode/base-node/vs/base/common/objects":
/*!***********************************************************!*\
  !*** external "@vscode/base-node/vs/base/common/objects" ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@vscode/base-node/vs/base/common/objects");

/***/ }),

/***/ "@workbench-stack/modal":
/*!*****************************************!*\
  !*** external "@workbench-stack/modal" ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/modal");

/***/ }),

/***/ "@workbench-stack/preferences-module-browser":
/*!**************************************************************!*\
  !*** external "@workbench-stack/preferences-module-browser" ***!
  \**************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/preferences-module-browser");

/***/ }),

/***/ "@workbench-stack/theme":
/*!*****************************************!*\
  !*** external "@workbench-stack/theme" ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/theme");

/***/ }),

/***/ "classnames":
/*!*****************************!*\
  !*** external "classnames" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("classnames");

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),

/***/ "react-apollo":
/*!*******************************!*\
  !*** external "react-apollo" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),

/***/ "react-dom":
/*!****************************!*\
  !*** external "react-dom" ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react-dom");

/***/ }),

/***/ "react-fela":
/*!*****************************!*\
  !*** external "react-fela" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),

/***/ "react-redux":
/*!******************************!*\
  !*** external "react-redux" ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),

/***/ "react-tooltip":
/*!********************************!*\
  !*** external "react-tooltip" ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react-tooltip");

/***/ }),

/***/ "reselect":
/*!***************************!*\
  !*** external "reselect" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("reselect");

/***/ })

/******/ });
//# sourceMappingURL=index.js.map