import * as React from 'react';
import { ISearchOptions } from '@finder-stack/client-core';
export declare type IFinderWrapperApiProps = {
    searchMutate?: Function;
    configuration?: any;
    subscribeToMore?: any;
    searchStreamMutate?: Function;
};
export declare type IFinderWrapperStateProps = {
    styles?: any;
    rootPath?: string;
    searchOptions?: ISearchOptions;
};
export declare type IFinderWrapperDispatchProps = {
    setError?: (error: string, type: string) => any;
    setSearchOptions?: (options: any) => any;
};
export declare type IFinderWrapperProps = IFinderWrapperStateProps & IFinderWrapperDispatchProps & IFinderWrapperApiProps;
export declare type IFinderWrapperState = {
    results?: any[];
};
export declare class FinderWrapperComponent extends React.Component<IFinderWrapperProps, IFinderWrapperState> {
    private containerRef;
    private subscriptions;
    constructor(props: IFinderWrapperProps);
    componentDidMount(): void;
    private search;
    render(): JSX.Element;
}
